;           DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
;                    Version 2, December 2004
;  
; Copyright (C) 2004 Sam Hocevar <sam@hocevar.net>
; 
; Everyone is permitted to copy and distribute verbatim or modified
; copies of this license document, and changing it is allowed as long
; as the name is changed.
;  
;            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
;   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
;  
;  0. You just DO WHAT THE FUCK YOU WANT TO.

;
; BPE text decoder for Marcher Maze
; author: MooZ
;
	.code
	.bank 2
	.org $89e2

l_89e2: LDY     $271b
		INC 	$271b
		stz		$271c
        LDA     [$5c], Y       ; Load char
		
        CMP     #$ff           ; [END]
        beq     l_8aaf         ; end of string routine

l_89ee: CMP     #$fc           ; [FC-CR]
        beq     l_8a7e         ; jump line

	inc	$271c
	pha

decode:	                       ; BPE decoding
	dec	$271c
	pla
	cmp	#ENCODED_CHAR_MIN
	bcc	display
	cmp	#ENCODED_CHAR_MAX
	bcs	display
		sec
		sbc	#ENCODED_CHAR_MIN
		tay

		lda	_bpe_second, Y
		pha
		inc	$271c

		lda	_bpe_first, Y
		pha
		inc	$271c

		bra	decode
display:
	clc
	adc     #$30
	STA     $0002              ; put char
	LDA     #$87
	adc     #$00
	STA     $0003

	INC     $2719
	LDA     $2719
	CMP     #$1C               ; check if we have reach the end of line
	BEQ     l_8a7e

	BRA check


l_8a7e: STZ     $2719          ; reset line char offset
        INC     $271a          ; increment line offset?

        CLC     
        LDA     <$5a           ; set Memory Address Write Register
        ADC     #$80
        STA     <$5a
        LDA     <$5b
        ADC     #$00
        STA     <$5b
        LDA     #$00
        STA     <$4a
        STA     $0000
        LDA     <$5a
        STA     $0002
        LDA     <$5b
		STA     $0003
        LDA     #$02            ; use vram data register
        STA     <$4a
        STA     $0000

check:
	lda	$271c
	bne	decode

	JMP     l_89e2

l_8aaf: INC     $2701          ; [END]
        JMP     $8cab

	.data
	.bank 0
	.org $fc60
	.include "text.asm"        ; generated by encodeScript

